C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Lnsall version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 LNSALL 23JUNE1997
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Allocates space within the common array for pathline coverages and 
C      attributes.
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C     LENX    : MAXIMUM DIMENSION OF THE COMMON BLOCK ARRAY
C     MAXATB  : MAXIMUM NUMBER OF ATTRIBUTES IN COVERAGE PAT OR AAT FILE
C     MAXPTS  : MAXIMUM NUMBER OF PARTICLE POSITIONS
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C
C   Inputs/Outputs:
C
C     ISUM    : INDEX NUMBER TO COMMON BLOCK ARRAY FOR ALLOCATION
C
C    Outputs:
C
C     LCATRB  : STARTING ARRAY INDEX FOR ARC ATTRIBUTE TABLE
C
C     Program:
C
C     ISUM1   : INDEX NUMBER TO LAST COMMON BLOCK ARRAY FOR ALLOCATION
C
C
C-------------------------------------------------------------------------
      SUBROUTINE LNSALL (
     I                   OUTUNT,
     I                   LENX,
     I                   MAXATB,MAXPTS,
     B                   ISUM,
     O                   LCATRB,
     E                   *)
C
C-------------------------------------------------------------------------
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C:::::::::::::::::::::::  GLOBAL_VARIABLES  ::::::::::::::::::::::::::::
C
      INTEGER
     &        OUTUNT,
     &        LENX,
     &        MAXATB,
     &        MAXPTS,
     &        ISUM,
     &        LCATRB
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(/)')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''          PATHLINE GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''             VERSION 6.0 23JUNE1997 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                 ALLOCATION MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(/)')
C
C1----Allocate space for arrays
C
      LCATRB=ISUM
      ISUM=ISUM+MAXATB*MAXPTS
      ISUM1=ISUM-1
C
C2----Print Modtools operation parameters
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''          PARTICLE PATHLINE ALLOCATION'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
C
      WRITE(OUTUNT,'(10X,
     &             I8,1X,
     &             ''MAXIMUM NUMBER OF PARTICLES '',
     &             ''IN PATHLINE COVERAGE'')')
     &          MAXPTS
C
      WRITE(OUTUNT,'(10X,
     &             I8,1X,
     &             ''MAXIMUM NUMBER OF ATTRIBUTES FOR EACH ARC '',
     &             ''IN PATHLINE COVERAGE'')')
     &          MAXATB
C
      ISP=MAXATB*MAXPTS
      WRITE(OUTUNT,'(10X,
     &             I8,1X,
     &             ''ELEMENTS IN COMMON BLOCK ARRAY USED '',
     &             ''FOR PATHLINE ARC PACKAGE'')')
     &          ISP
C
      WRITE(OUTUNT,'(10X,
     &             I8,1X,
     &             ''ELEMENTS OF COMMON BLOCK ARRAY USED OUT OF '',
     &             I8)')
     &          ISUM1,LENX
      WRITE(OUTUNT,'(10X,85(''-''))')
C
C3----Check amount of space used
C
      IF(ISUM1.GT.LENX) THEN
         WRITE(OUTUNT,'(//,
     &                ''    ***CELL ARRAY MUST BE DIMENSIONED '',
     &                ''LARGER*** ISUM '',I10,'' > LENX '',I10)')
     &             ISUM1,
     &             LENX
         WRITE(OUTUNT,'(//,
     &             '' Abnormal termination of Lnsall_Subroutine'')')
         WRITE (*,'(//,'' Cell array must be dimensioned larger ISUM '',
     &              I10,'' > LENX '',I10)')
     &           ISUM1,
     &           LENX
         WRITE(*,'(//,
     &             '' Abnormal termination of Lnsall_Subroutine'')')
         RETURN 1
      ENDIF
C
C4----Return
C
      RETURN
      END
C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Pthlns version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 PTHLNS 12MAY1998
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Generates a pathline coverage from simulation results of the particle
C      tracking program MODPATH using the pathline option under steady-state
C      or transient conditions.  Particles locations and attributes are
C      recorded in the PATHLINE file.
C     This program uses an algorithm that traces a single particle along
C      one pathline.  Each pathline may consist of many segments or arcs.
C      The algorithm separates each pathline into many segments using
C      each record from the pathline file  Values of time-of-travel
C      and other attributes are computed for each segment.
C        Attributes for each segment for one particle are attached to
C      reflect the original particle id number, it's original starting 
C      position within the model grid, and it's final position within
C      the model grid.  
C       -- Starting attributes are those attributes associated with the start 
C           of the particle-tracking simulation.  These data are computed
C           using the first record for each particle.
C       -- Last attributes are those that indicate the previous position or
C           the last record for a particle.  
C       -- Present attributes are those attributes that represent the 
C           present position or record in the pathline file.
C       -- Cumulative attributes are those attributes that are measured from
C           start position to the present position.
C       -- Final attributes are those attributes that occur at the final 
C           time t and are measured from start position to final position.
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C     PTHFIL  : MODPATH OUTPUT PATHLINE PARTICLE FILE NAME
C     PTHUNT  : FORTRAN UNIT NUMBER TO PATHLINE PARTICLE FILE
C     PRTCOV  : USER DEFINED PARTICLE COVERAGE NAME
C     MAXATB  : MAXIMUM DIMENSION OF THE NUMBER OF PARTICLE ATTRIBUTES
C     MAXPMR  : MAXIMUM NUMBER OF COVERAGE PARAMETERS
C     MAXPTS  : MAXIMUM DIMENSION OF THE NUMBER OF LABEL (MAXARC*MAXPTS)
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     DELX    : ARRAY FOR CELL WIDTHS IN ROW/COLUMN/PARTICLE DIRECTION
C     COVPMR  : COVERAGE PARAMETERS ARRAY (MAXPMR)
C     IBOUND  : ARRAY FOR IBOUND ARRAY
C
C    Outputs:
C
C     PARTLE  : ARC ATTRIBUTE ARRAY (MAXPTS,MAXATB)
C
C-------------------------------------------------------------------------
      SUBROUTINE PTHLNS (
     I                   OUTUNT,
     I                   PTHFIL,PTHUNT,
     I                   PRTCOV,
     I                   MAXATB,MAXPMR,MAXPTS,
     I                   NLAY,NROW,NCOL,
     I                   DELX,COVPMR,
     I                   IBOUND,
     O                   PARTLE,
     E                   *)
C-----------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
      DIMENSION 
     &          COVPMR(MAXPMR),
     &          DELX(NCOL*NROW),
     &          PARTLE(MAXPTS,MAXATB),
     &          IBOUND(NCOL,NROW,NLAY)
C
      CHARACTER*(*) PRTCOV,PTHFIL
      INTEGER 
     &        OUTUNT,
     &        PTHUNT
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      PARAMETER 
     &          (MAXITM=63,
     &           MXITEM=5)
C
      CHARACTER*400 BUFFER
      CHARACTER*128 COVFIL
      CHARACTER*80 STRFIL,LSTFIL,PREFIL,FINFIL,CUMFIL,
     &             GENFIL,ARCFIL,ADDFIL,JONFIL,TMPFIL,
     &             BUFTXT
      CHARACTER*16 ARCCMD,ACTION,STRITM,RELITM,JONTYP,
     &             COVTYP,ITEMS(MAXITM)
      CHARACTER*1 TYPES(MAXITM)
C
      REAL
     &     XGC,YGC,ZGC,XTO,XFROM,
     &     XLC,YLC,ZLC,YTO,YFROM
C
      INTEGER 
     &        STRUNT,LSTUNT,PREUNT,FINUNT,CUMUNT,
     &        GENUNT,ARCUNT,
     &        DECIMLS(MAXITM),
     &        ITMSTR(MXITEM),ITMFIN(MXITEM),
     &        OUTPUTS(MAXITM),
     &        WIDTHS(MAXITM)
C
      INTEGER 
     &        COL,ROW,LAY,BUFDEX,COMPCT,BINARY,
     &        ICOVER,MODFLG,MODFMT,IVIEW,IRWCL,
     &        IDPART,PARTID,TIMSTP,OLDSTP,MODOLD,
     &        STRCOL,STRROW,STRLAY,STRIBD,STRSTP,
     &        LSTCOL,LSTROW,LSTLAY,LSTIBD,
     &        PRECOL,PREROW,PRELAY,PREIBD,PRESTP,
     &        FINCOL,FINROW,FINLAY,FINIBD,FINSTP,
     &        TOTPTS,NEWPTS,OLDPTS,TOTREC,
     &        TOTARC,TOTSTN,TOTPRT,TOTCOT,PRTSTP
C
      EXTERNAL OPEN_FILE,CLOSE_FILE,DELETE_FILE
C
      DATA STRFIL,STRUNT /'startitems',98/
      DATA LSTFIL,LSTUNT /'lastitems',97/ 
      DATA PREFIL,PREUNT /'presentitems',96/
      DATA FINFIL,FINUNT /'finalitems',95/
      DATA CUMFIL,CUMUNT /'cumitems',94/
      DATA GENFIL,GENUNT /'arcs',93/
      DATA ARCFIL,ARCUNT /'arccmd',92/
C
      DATA ITMSTR /1, 14,25,42,59/
      DATA ITMFIN /13,24,41,58,63/
      DATA ITEMS /'PARTID','STRSTP',
     &            'STRROW','STRCOL','STRLAY','STRIBD',
     &            'STRXGC','STRXLC',
     &            'STRYGC','STRYLC',
     &            'STRZGC','STRZLC',
     &            'STRTIM',
     &            'LSTROW','LSTCOL','LSTLAY','LSTIBD',
     &            'LSTXGC','LSTXLC',
     &            'LSTYGC','LSTYLC',
     &            'LSTZGC','LSTZLC',
     &            'LSTTIM',
     &            'PRESTP',
     &            'PREROW','PRECOL','PRELAY','PREIBD',
     &            'PREXGC','PREXLC',
     &            'PREYGC','PREYLC',
     &            'PREZGC','PREZLC',
     &            'PRETIM',
     &            'PRETRV',
     &            'PREXVL','PREYVL','PREZVL','PRESPD',
     &            'PARTID','FINSTP',
     &            'FINROW','FINCOL','FINLAY','FINIBD',
     &            'FINXGC','FINXLC',
     &            'FINYGC','FINYLC',
     &            'FINZGC','FINZLC',
     &            'FINTIM',
     &            'FINXVL','FINYVL','FINZVL','FINSPD',
     &            'CUMXVL','CUMYVL','CUMZVL','CUMSPD','MODSTP'/
C
      DATA DECIMLS / 6*0,  7*3,  4*0,  7*3,  5*0,  8*3,  4*8,  6*0,
     &                7*3,  8*8,0/
      DATA TYPES   / 6*'I',7*'F',4*'I',7*'F',5*'I',8*'F',4*'F',6*'I',
     &                11*'F',4*'F','I'/
      DATA WIDTHS  / 6*10, 7*8,  4*10, 7*8,  5*10, 8*8,  4*8,  6*10,
     &                11*8,  4*8,10/
      DATA OUTPUTS / 6*10, 7*16, 4*10, 7*16, 5*10, 8*16, 4*16, 6*10,
     &                11*16, 4*16,10/
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''          PATHLINE GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''               VERSION 6.0 12MAY1998 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                  GIS OUTPUT MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C1L----Set local variables
C
      XYSCALE=COVPMR(3)
      ZSCALE=COVPMR(4)
      ANGLE=COVPMR(5)
      XOGRID=COVPMR(6)
      YOGRID=COVPMR(7)
      IF(COVPMR(9).LE.0.0) COVPMR(9)=1.0
      HSCALE=12.0/COVPMR(9)
      IF(COVPMR(8).LE.0.0) COVPMR(8)=1.0
      VSCALE=HSCALE*COVPMR(8)
      IVIEW=INT(COVPMR(10))
      IRWCL=INT(COVPMR(11))
      YMIN=COVPMR(MAXPMR)
      MODFMT=INT(COVPMR(MAXPMR-4))
      MODFMT=MODFMT/100
      MODSTP=0
      NPER=INT(COVPMR(17))
C
C1G----Set global variables
C
      DO 100 N=1,MAXPTS
         PARTLE(N,1)=-99
         PARTLE(N,2)=0
         PARTLE(N,25)=0
         PARTLE(N,43)=0
 100  CONTINUE
C
C2----Transform from Modpath origin (lower left) to Modular Model
C      origin (upper left)
C
      YORIGN=0.0
C
C2A----Calculate upper left corner distance from DELC array (y-axis)
C
      DO 200 ROW=NCOL+1,NCOL+NROW
         YORIGN=YORIGN+DELX(ROW)
  200 CONTINUE
C
C2B----Calculate rowcol attribute definition
C
      IF(NROW.LT.10) THEN
         LENROW=1
      ELSE IF(NROW.GT.9 .AND. NROW.LT.100) THEN
         LENROW=2
      ELSE IF(NROW.GT.99 .AND. NROW.LT.1000) THEN
         LENROW=3
      ELSE
         LENROW=4
      ENDIF
C
      IF(NCOL.LT.10) THEN
         LENCOL=1
      ELSE IF(NCOL.GT.9 .AND. NCOL.LT.100) THEN
         LENCOL=2
      ELSE IF(NCOL.GT.99 .AND. NCOL.LT.1000) THEN
         LENCOL=3
      ELSE
         LENCOL=4
      ENDIF
C
      IF(NLAY.LT.10) THEN
         LENLAY=1
      ELSE IF(NLAY.GT.9 .AND. NLAY.LT.100) THEN
         LENLAY=2
      ELSE IF(NLAY.GT.99 .AND. NLAY.LT.1000) THEN
         LENLAY=3
      ELSE
         LENLAY=4
      ENDIF
C
      WIDTHS(3)=LENROW
      OUTPUTS(3)=LENROW
      WIDTHS(4)=LENCOL
      OUTPUTS(4)=LENCOL
      WIDTHS(5)=LENLAY
      OUTPUTS(5)=LENLAY
C
      WIDTHS(14)=LENROW
      OUTPUTS(14)=LENROW
      WIDTHS(15)=LENCOL
      OUTPUTS(15)=LENCOL
      WIDTHS(16)=LENLAY
      OUTPUTS(16)=LENLAY
C
      WIDTHS(26)=LENROW
      OUTPUTS(26)=LENROW
      WIDTHS(27)=LENCOL
      OUTPUTS(27)=LENCOL
      WIDTHS(28)=LENLAY
      OUTPUTS(28)=LENLAY
C
      WIDTHS(44)=LENROW
      OUTPUTS(44)=LENROW
      WIDTHS(45)=LENCOL
      OUTPUTS(45)=LENCOL
      WIDTHS(46)=LENLAY
      OUTPUTS(46)=LENLAY
C
C3----Delete and create files for item names of particle attributes
C
      CALL ITEM_FILES (
     I                 STRFIL,STRUNT,
     I                 ITMSTR(1),ITMFIN(1),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 LSTFIL,LSTUNT,
     I                 ITMSTR(2),ITMFIN(2),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 PREFIL,PREUNT,
     I                 ITMSTR(3),ITMFIN(3),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 FINFIL,FINUNT,
     I                 ITMSTR(4),ITMFIN(4),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 CUMFIL,CUMUNT,
     I                 ITMSTR(5),ITMFIN(5),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
C
C3----Delete/create files containing particle locations and attributes
C       and Arc command files
C
      NSTAT=2
      ITALK=1
      STRFIL='start'
      CALL DELETE_FILE (STRFIL,*9999)
      CALL OPEN_FILE (STRUNT,STRFIL,NSTAT,ITALK,*9999)
      LSTFIL='last'
      CALL DELETE_FILE (LSTFIL,*9999)
      CALL OPEN_FILE (LSTUNT,LSTFIL,NSTAT,ITALK,*9999)
      PREFIL='present'
      CALL DELETE_FILE (PREFIL,*9999)
      CALL OPEN_FILE (PREUNT,PREFIL,NSTAT,ITALK,*9999)
      CUMFIL='cum'
      CALL DELETE_FILE (CUMFIL,*9999)
      CALL OPEN_FILE (CUMUNT,CUMFIL,NSTAT,ITALK,*9999)
      GENFIL='arcs'
      CALL DELETE_FILE (GENFIL,*9999)
      CALL OPEN_FILE (GENUNT,GENFIL,NSTAT,ITALK,*9999)
C
C4----Open pathline file
C
      IF(PTHUNT.LE.0) THEN    
         WRITE(*,'(
     &             ''      .No pathline file listed '',
     &             ''in MODPATH name file'')')
         WRITE(OUTUNT,'(
     &             ''      .No pathline file listed '',
     &             ''in MODPATH name file'')')
         GO TO 9999
      ELSE
       IF(NPER.EQ.0) THEN
          MODPER=1
          MODSTP=1
          WRITE(*,'(
     &             ''      .Processing steady-state pathlines '',
     &             ''from file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
          WRITE(OUTUNT,'(
     &             ''      .Processing steady-state pathlines '',
     &             ''from file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
       ELSE
          WRITE(*,'(
     &             ''      .Processing transient pathlines '',
     &             ''from file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
          WRITE(OUTUNT,'(
     &             ''      .Processing transient pathlines '',
     &             ''from file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
       ENDIF
      ENDIF
C
C4A----Determine particle format
C
      IF(MODFMT.LT.1) THEN    
         WRITE(*,'(7X,
     &             ''..Using standard text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.1) THEN    
         WRITE(*,'(7X,
     &             '' Using compact text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ELSE
         WRITE(*,'(7X,
     &             '' Using binary text format'')')
         NSTAT=1
         ITALK=1
         PTHUNT=-1*ABS(PTHUNT)
C         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
         PTHUNT=ABS(PTHUNT)
         OPEN(PTHUNT,ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      ENDIF
C
C4C----Read header line from pathline file
C
      IF(MODFMT.LT.2) THEN    
         READ(PTHUNT,'(A)',ERR=9990,END=9991) BUFFER
         MODPTH=INDEX(BUFFER,'Version 3.00')
         COMPCT=INDEX(BUFFER,'(COMPACT)')
         BUFDEX=INDEX(BUFFER,'TREF=')
       IF(BUFDEX.GT.0) THEN
          BUFFER=BUFFER (BUFDEX+5:LEN(BUFFER))
          BUFDEX=INDEX(BUFFER,')')
        IF(BUFDEX.LE.0) BUFDEX=LEN(BUFFER)
          READ(BUFFER (1:BUFDEX-1),*) TREF
       ELSE
          TREF=0.0
       ENDIF
      ELSE
         READ(PTHUNT,ERR=9990,END=9991) BUFTXT,TREF
         MODPTH=INDEX(BUFFER,'Version 3.00')
         BINARY=INDEX(BUFFER,'(BINARY)')
      ENDIF
C
C4C----Check format of pathline file
C
      IF(MODFMT.EQ.0 .AND. MODPTH.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in MODPATH version 3.0 text format '')')
         WRITE(*,'(''      ..Using standard text format '',
     &             ''for MODPATH version 2.0 '')')
         MODFMT=9
         CALL CLOSE_FILE (PTHFIL,*9999)
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ENDIF
C
      IF(MODFMT.EQ.1 .AND. COMPCT.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in compact format '')')
         GO TO 9999
      ENDIF
C
      IF(MODFMT.EQ.2 .AND. BINARY.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in binary format '')')
         GO TO 9999
      ENDIF
C
C4B---Set particle counting variables
C
      TOTPRT=0
      TOTREC=0
      TOTARC=0
      TOTCOT=0
      TIMSTP=0
C
C4D---Loop to read arcs from pathline file
C
  402 IF(MODFMT.LT.1) THEN    
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           COL,ROW,LAY,
     &           MODSTP
      ELSE IF(MODFMT.EQ.1) THEN
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           NODE,
     &           MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE IF(MODFMT.EQ.2) THEN
         READ(PTHUNT,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           NODE,
     &           MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           COL,ROW,LAY
         MODSTP=0
      ENDIF
C
C4Da----Count particle positions
C
        TOTREC=TOTREC+1
      IF(IDPART.GT.MAXPTS) GO TO 9993
C
C4Db----Compute local x-,y-coordinates
C
      CALL LOCAL_COORDINATES (
     I                        NCOL,NROW,
     I                        DELX,
     I                        COL,ROW,
     I                        XGC,YGC,YORIGN,
     O                        XLC,YLC)
C
C4Dc----Compute arc node points, transform and assign coordinates,
C--------and obtain particle-time
C
      XGC=XGC*XYSCALE
       YGC=(YGC-YORIGN)*XYSCALE
        ZGC=ZGC*ZSCALE
      IF(IVIEW.LE.0) THEN
       IF(ANGLE.NE.0.0) THEN
          CALL ROTATE (
     I                 ANGLE,
     B                 XGC,YGC)
       ENDIF
         XGC=XGC+XOGRID
         YGC=YGC+YOGRID
         XTO=XGC
         YTO=YGC
      ELSE IF(IVIEW.EQ.1) THEN
         XTO=XGC*HSCALE
         YTO=ZGC*VSCALE-YMIN
      ELSE
         XTO=-1.0*YGC*HSCALE
         YTO=ZGC*VSCALE-YMIN
      ENDIF
C
C4Dd----Test time step index number and particle ids
C
      IF(TIME.LE.0) THEN
         PRTSTP=PARTLE(IDPART,25)
       IF(PRTSTP.GE.0) THEN
        IF(TIMSTP.NE.OLDSTP) THEN
           NUMSTP=NUMSTP+1
           TIMSTP=TIMSTP+1
           OLDSTP=TIMSTP
        ENDIF
       ELSE
          PARTLE(IDPART,2)=TIMSTP
       ENDIF
      ENDIF
C
         TIME=ABS(TIME)
       IF(TIME.LT.0.0000000000001) TIME=0.0
C
C4De-----Load particle_id and time_step attributes
C
         PARTID=PARTLE(IDPART,1)
C
C4Df-----Load start and print attributes
C
      IF(PARTID.LT.1) THEN
         TOTPRT=TOTPRT+1
         NEWPTS=NEWPTS+1
         NEWPRT=NEWPRT+1
         PARTLE(IDPART,1)=IDPART
         PARTLE(IDPART,2)=TIMSTP
         PARTLE(IDPART,3)=ROW
         PARTLE(IDPART,4)=COL
         PARTLE(IDPART,5)=LAY
         PARTLE(IDPART,6)=IBOUND(COL,ROW,LAY)
         PARTLE(IDPART,7)=XGC
         PARTLE(IDPART,8)=XLC
         PARTLE(IDPART,9)=YGC
         PARTLE(IDPART,10)=YLC
         PARTLE(IDPART,11)=ZGC
         PARTLE(IDPART,12)=ZLC
         PARTLE(IDPART,13)=TIME
C
C4Dg---Filter coordinates that when projected on mapview or
C--------vertical profile are concident
C
      ELSE
         OLDPTS=OLDPTS+1
       IF(IVIEW.LE.0) THEN
          XFROM=PARTLE(IDPART,18)
          YFROM=PARTLE(IDPART,20)
       ELSE IF(IVIEW.EQ.1) THEN
          XFROM=PARTLE(IDPART,18)*HSCALE
          YFROM=PARTLE(IDPART,22)*VSCALE-YMIN
       ELSE
          XFROM=-1.0*PARTLE(IDPART,20)*HSCALE
          YFROM=PARTLE(IDPART,22)*VSCALE-YMIN
       ENDIF
         XGCDIF=ABS(XTO-XFROM)
         YGCDIF=ABS(YTO-YFROM)
         MODOLD=PARTLE(IDPART,63)
       IF(XGCDIF.LE.0.0001 .AND. YGCDIF.LE.0.0001) THEN
          TOTCOT=TOTCOT+1
        IF(TOTCOT.LE.1) THEN
           WRITE(OUTUNT,'(//,1H1,32X,
     &               ''  POTENTIALLY CONCIDENT PARTICLE POSITIONS '')')
           WRITE(OUTUNT,'(/15X,
     &               ''  IF POSITIONS WERE NOT COMPUTED AT '',
     &               ''SPECIFIC POINTS IN TIME UNDER STEADY-STATE '',
     &               ''CONDITIONS'')')
           WRITE(OUTUNT,'(10X,105(''-''))')
           WRITE(OUTUNT,'(/10X,
     &               '' PARTICLE ID'',
     &               ''    COLUMN'',
     &               ''       ROW'',
     &               ''     LAYER'',
     &               ''       X DIFFERENCE'',
     &               ''       Y DIFFERENCE'',
     &               ''                TIME'')')
           WRITE(OUTUNT,'(/10X,105(''-''))')
         ENDIF
          WRITE(OUTUNT,'(10X,I12,I10,I10,I10,2(F19.5,1X),F20.3)')
     &                                                 IDPART,
     &                                                 COL,
     &                                                 ROW,
     &                                                 LAY,
     &                                                 XGCDIF,
     &                                                 YGCDIF,
     &                                                 TIME
          GO TO 402
       ENDIF
      ENDIF
C
      IF(PARTID.GT.0) THEN
         IDPART=PARTLE(IDPART,1)
         STRSTP=PARTLE(IDPART,2)
         STRROW=PARTLE(IDPART,3)
         STRCOL=PARTLE(IDPART,4)
         STRLAY=PARTLE(IDPART,5)
         STRIBD=PARTLE(IDPART,6)
         WRITE(STRUNT,'(6(I10,'',''),
     &                  6(G16.6,'',''),
     &                  1(G16.3,'',''))')
     &                                   IDPART,
     &                                   STRSTP,
     &                                   STRROW,
     &                                   STRCOL,
     &                                   STRLAY,
     &                                   STRIBD,
     &                                   (PARTLE(IDPART,M), M=7,13)
      ENDIF
C
C4Dh----Load present attributes
C
      PARTLE(IDPART,25)=TIMSTP
      PARTLE(IDPART,26)=ROW
      PARTLE(IDPART,27)=COL
      PARTLE(IDPART,28)=LAY
      PARTLE(IDPART,29)=IBOUND(COL,ROW,LAY)
      PARTLE(IDPART,30)=XGC
      PARTLE(IDPART,31)=XLC
      PARTLE(IDPART,32)=YGC
      PARTLE(IDPART,33)=YLC
      PARTLE(IDPART,34)=ZGC
      PARTLE(IDPART,35)=ZLC
      PARTLE(IDPART,36)=TIME
C
      IF(PARTID.LT.1) THEN
         PARTLE(IDPART,37)=0.0
         PARTLE(IDPART,38)=0.0
         PARTLE(IDPART,39)=0.0
         PARTLE(IDPART,40)=0.0
         XGCVEL=0.0
         YGCVEL=0.0
         ZGCVEL=0.0
         PRTSPD=0.0
         XGCPTH=0.0
         YGCPTH=0.0
         ZGCPTH=0.0
         ARCPTH=0.0
         TRVTIM=0.0
      ELSE
         TRVTIM=ABS(TIME-PARTLE(IDPART,24))
         PARTLE(IDPART,37)=TRVTIM
        IF(TRVTIM.LE.0.0) THEN
           XGCVEL=0.0
           YGCVEL=0.0
           ZGCVEL=0.0
           PRTSPD=0.0
           XGCPTH=0.0
           YGCPTH=0.0
           ZGCPTH=0.0
           ARCPTH=0.0
        ELSE
           XGCPTH=XGC-PARTLE(IDPART,18)
           YGCPTH=YGC-PARTLE(IDPART,20)
           ZGCPTH=ZGC-PARTLE(IDPART,22)
           ARCPTH=(XGCPTH**2+YGCPTH**2+ZGCPTH**2)**0.5
           XGCVEL=XGCPTH/TRVTIM
           YGCVEL=YGCPTH/TRVTIM
           ZGCVEL=ZGCPTH/TRVTIM
           PRTSPD=ARCPTH/TRVTIM
         IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
         IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
         IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
         IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
        ENDIF
          PARTLE(IDPART,38)=XGCVEL
          PARTLE(IDPART,39)=YGCVEL
          PARTLE(IDPART,40)=ZGCVEL
          PARTLE(IDPART,41)=PRTSPD
C
         PRESTP=PARTLE(IDPART,25)
         PREROW=PARTLE(IDPART,26)
         PRECOL=PARTLE(IDPART,27)
         PRELAY=PARTLE(IDPART,28)
         PREIBD=PARTLE(IDPART,29)
         WRITE(PREUNT,'(5(I5,'',''),
     &                  6(G16.6,'',''),
     &                  2(G16.3,'',''),
     &                  4(G16.8,'',''))')
     &                                 PRESTP,
     &                                 PREROW,
     &                                 PRECOL,
     &                                 PRELAY,
     &                                 PREIBD,
     &                                 (PARTLE(IDPART,M), M=30,41)
      ENDIF
C
C4Di----Load and print last attributes
C
      IF(PARTID.GT.0) THEN
         LSTROW=PARTLE(IDPART,14)
         LSTCOL=PARTLE(IDPART,15)
         LSTLAY=PARTLE(IDPART,16)
         LSTIBD=PARTLE(IDPART,17)
         WRITE(LSTUNT,'(4(I10,'',''),
     &                  6(G16.6,'',''),
     &                  1(G16.3,'',''))')
     &                                   LSTROW,
     &                                   LSTCOL,
     &                                   LSTLAY,
     &                                   LSTIBD,
     &                                   (PARTLE(IDPART,M), M=18,24)
      ENDIF
C
      PARTLE(IDPART,14)=ROW
      PARTLE(IDPART,15)=COL
      PARTLE(IDPART,16)=LAY
      PARTLE(IDPART,17)=IBOUND(COL,ROW,LAY)
      PARTLE(IDPART,18)=XGC
      PARTLE(IDPART,19)=XLC
      PARTLE(IDPART,20)=YGC
      PARTLE(IDPART,21)=YLC
      PARTLE(IDPART,22)=ZGC
      PARTLE(IDPART,23)=ZLC
      PARTLE(IDPART,24)=TIME

C
C4Dj----Load final attributes
C
      PARTLE(IDPART,42)=IDPART
      PARTLE(IDPART,43)=TIMSTP
      PARTLE(IDPART,44)=ROW
      PARTLE(IDPART,45)=COL
      PARTLE(IDPART,46)=LAY
      PARTLE(IDPART,47)=IBOUND(COL,ROW,LAY)
      PARTLE(IDPART,48)=XGC
      PARTLE(IDPART,49)=XLC
      PARTLE(IDPART,50)=YGC
      PARTLE(IDPART,51)=YLC
      PARTLE(IDPART,52)=ZGC
      PARTLE(IDPART,53)=ZLC
      PARTLE(IDPART,54)=TIME
      PARTLE(IDPART,55)=PARTLE(IDPART,55)+XGCPTH
      PARTLE(IDPART,56)=PARTLE(IDPART,56)+YGCPTH
      PARTLE(IDPART,57)=PARTLE(IDPART,57)+ZGCPTH
      PARTLE(IDPART,58)=PARTLE(IDPART,58)+ARCPTH
C
C4Dk----Load cumulative attributes
C
      STRTIM=PARTLE(IDPART,13)
      TRVTIM=ABS(TIME-STRTIM)
C
      IF(TRVTIM.LE.0.0) THEN
         XGCVEL=0.0
         YGCVEL=0.0
         ZGCVEL=0.0
         PRTSPD=0.0
      ELSE
         XGCPTH=PARTLE(IDPART,55)
         YGCPTH=PARTLE(IDPART,56)
         ZGCPTH=PARTLE(IDPART,57)
         XGCVEL=XGCPTH/TRVTIM
         YGCVEL=YGCPTH/TRVTIM
         ZGCVEL=ZGCPTH/TRVTIM
         ARCPTH=(XGCPTH**2+YGCPTH**2+ZGCPTH**2)**0.5
         PRTSPD=ARCPTH/TRVTIM
       IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
       IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
       IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
       IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
      ENDIF
C
      PARTLE(IDPART,59)=XGCVEL
      PARTLE(IDPART,60)=YGCVEL
      PARTLE(IDPART,61)=ZGCVEL
      PARTLE(IDPART,62)=PRTSPD
      PARTLE(IDPART,63)=MODSTP
C
      IF(PARTID.GT.0) THEN
         TOTARC=TOTARC+1
         WRITE(CUMUNT,'(4(G16.8,'',''),
     &                  I10)')
     &                                (PARTLE(IDPART,M), M=59,62),
     &                                MODSTP
      ENDIF
C
C4Dl----Write coordinates and label-ids to generate file
C
      IF(PARTID.GT.0) THEN
         WRITE(GENUNT,'(I10)') IDPART
         WRITE(GENUNT,'(F20.10,'','',F20.10,/,
     &                  F20.10,'','',F20.10)')
     &                                             XFROM,
     &                                             YFROM,
     &                                             XTO,
     &                                             YTO
         WRITE(GENUNT,'(''END'')')
      ENDIF
C
C4Am----Read another record from pathline file
C
       GO TO 402
C
C5A----Add "end" to generate file file
C
  502 WRITE(GENUNT,'(''END'')')
C
C5C----Close PTHFIL, arc attribute, and generate files
C
      CALL CLOSE_FILE (PTHFIL,*9999)
      CALL CLOSE_FILE (STRFIL,*9999)
      CALL CLOSE_FILE (LSTFIL,*9999)
      CALL CLOSE_FILE (PREFIL,*9999)
      CALL CLOSE_FILE (CUMFIL,*9999)
      CALL CLOSE_FILE (GENFIL,*9999)
C
C5An---Check the number of particles
C
      IF(TOTREC.LE.0) THEN
         WRITE(*,'(''      .No particle records found in '',
     &             ''Pathline file '',
     &          A)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1)
         GO TO 9999
      ENDIF
C
C6----Write final arc attribute
C
      TOTSTN=0
C
C6A----Delete/create file containing final particle attributes
C
      NSTAT=2
      ITALK=1
      FINFIL='final'
      CALL DELETE_FILE (FINFIL,*9999)
      CALL OPEN_FILE (FINUNT,FINFIL,NSTAT,ITALK,*9999)
C
C6B----Compute and load final attributes
C
      DO 600 N=1,TOTREC
         IDPART=PARTLE(N,1)
       IF(IDPART.LE.0) GO TO 600
         STRTIM=PARTLE(IDPART,13)
         FINTIM=PARTLE(IDPART,54)
       IF(STRTIM.EQ.FINTIM) THEN
        IF(TOTSTN.LE.0) THEN
           WRITE(OUTUNT,'(//,1H1,30X,
     &                    ''  PARTICLES THAT REMAINED STATIONARY '',
     &                    ''IN PATHLINE COVERAGE'',
     &                    /10X,85(''-''),/10X,
     &                   ''  PARTICLE-ID'',
     &                   4(''          STARTING''),/,
     &                   35X,''ROW'',
     &                   15X,''COLUMN'',
     &                   13X,''LAYER'',
     &                   12X,''IBOUND'',
     &                    /10X,85(''-''))')
        ENDIF
          TOTSTN=TOTSTN+1
          STRROW=PARTLE(IDPART,3)
          STRCOL=PARTLE(IDPART,4)
          STRLAY=PARTLE(IDPART,5)
          STRIBD=PARTLE(IDPART,6)
          WRITE(OUTUNT,'(13X,I10,4(8X,I10))')
     &                IDPART,
     &                STRROW,
     &                STRCOL,
     &                STRLAY,
     &                STRIBD
       ELSE
          FINSTP=PARTLE(IDPART,43)
          FINROW=PARTLE(IDPART,44)
          FINCOL=PARTLE(IDPART,45)
          FINLAY=PARTLE(IDPART,46)
          FINIBD=PARTLE(IDPART,47)
          TRVTIM=ABS(FINTIM-STRTIM)
C
        IF(TRVTIM.LE.0.0) THEN
           XGCVEL=0.0
           YGCVEL=0.0
           ZGCVEL=0.0
           PRTSPD=0.0
        ELSE
           XGCPTH=PARTLE(IDPART,55)
           YGCPTH=PARTLE(IDPART,56)
           ZGCPTH=PARTLE(IDPART,57)
           XGCVEL=XGCPTH/TRVTIM
           YGCVEL=YGCPTH/TRVTIM
           ZGCVEL=ZGCPTH/TRVTIM
           ARCPTH=(XGCPTH**2+YGCPTH**2+ZGCPTH**2)**0.5
           PRTSPD=ARCPTH/TRVTIM
         IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
         IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
         IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
         IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
        ENDIF
           PARTLE(IDPART,55)=XGCVEL
           PARTLE(IDPART,56)=YGCVEL
           PARTLE(IDPART,57)=ZGCVEL
           PARTLE(IDPART,58)=PRTSPD
           WRITE(FINUNT,'(I10,'','',
     &                    5(I5,'',''),
     &                    6(G16.6,'',''),
     &                    1(G16.3,'',''),
     &                    4(G16.8,'',''))')
     &                                    IDPART,
     &                                    FINSTP,
     &                                    FINROW,
     &                                    FINCOL,
     &                                    FINLAY,
     &                                    FINIBD,
     &                                    (PARTLE(IDPART,M), M=48,58)
        ENDIF
  600 CONTINUE
C
C6C----Close all attribute and generate files
C
      CALL CLOSE_FILE (FINFIL,*9999)
C
C7----Messages
C
C
C7A----Message to user
C
      WRITE(*,'(''      Pathline coverage '',A,
     &          '' consists of '')')
     &        PRTCOV (1:INDEX(PRTCOV,' ')-1)
      WRITE(*,'(''      .'',I10,
     &          '' total number of particle records'')')
     &        TOTREC
      WRITE(*,'(''      .'',I10,
     &          '' total number of particles found'')')
     &        TOTPRT
      WRITE(*,'(''      .'',I10,
     &          '' number of pathline segments generated '')')
     &        TOTARC
      WRITE(*,'(''      .'',I10,
     &          '' particles that remained stationary'')')
     &        TOTSTN
      WRITE(*,'(''      .'',I10,
     &          '' particle records that are concident '',
     &          ''when projected or were duplicate records'')')
     &        TOTCOT
      WRITE(*,'(''      .'',G16.7,
     &          '' simulation reference time '')')
     &       TREF
C
C7B----Message to operational output file
C
      WRITE(OUTUNT,'(''      Pathline coverage '',A,
     &          '' consists of '')')
     &        PRTCOV (1:INDEX(PRTCOV,' ')-1)
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' total number of particle records'')')
     &        TOTREC
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' total number of particles found'')')
     &        TOTPRT
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' number of pathline segments generated '')')
     &        TOTARC
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' particles that remained stationary'')')
     &        TOTSTN
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' particle records that are concident '',
     &          ''when projected or were duplicate records'')')
     &        TOTCOT
      WRITE(OUTUNT,'(''      .'',G16.7,
     &          '' simulation reference time '')')
     &       TREF
C
C8----Arc Operations to coverage and attribute files
C
      NSTAT=2
      ITALK=1
      ARCFIL='arccmd'
      CALL DELETE_FILE (ARCFIL,*9999)
      CALL OPEN_FILE (ARCUNT,ARCFIL,NSTAT,ITALK,*9999)
C
C8A----Create pathline coverage
C
      ARCCMD='create'
      WRITE(ARCUNT,'(A,1X,A)') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1)
C
C8B----Create attribute files and "add from" attributes
C
      ARCCMD='tables'
      TMPFIL='startitems'
      ADDFIL='start'
      ACTION='kill'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='lastitems'
      ADDFIL='last'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='presentitems'
      ADDFIL='present'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='finalitems'
      ADDFIL='final'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='cumitems'
      ADDFIL='cum'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
C
C8C----Generate Coverage PRTCOV
C
      ARCCMD='generate'
      COVTYP='lines'
      JONFIL='arcs'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
C
C8D----Build Coverage PRTCOV
C
      ARCCMD='build'
      COVTYP='line'
      WRITE(ARCUNT,'(A,2(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
C
C8E---Join attribute files start, present,final to Coverage PRTCOV AAT file
C
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='cum'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='present'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='last'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='start'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='final'
      RELITM='PARTID'
      STRITM=ITEMS(ITMFIN(1))
      JONTYP='ordered'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
C
C8F----Close arc commands file
C
      CALL CLOSE_FILE (ARCFIL,*9999)
       GO TO 1000
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                        Program Errors
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
CE*********************************************************************C
 9990 WRITE(*,'(//,'' Unable to read first line from Pathline file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read first line from Pathline file'')')
      CALL CLOSE_FILE (PTHFIL,*9999)
      GO TO 9999
 9991 WRITE(*,'(//,'' Premature end-of-line error in Pathline file'')')
      WRITE(OUTUNT,
     &      '(//,'' Premature end-of-line error in Pathline file'')')
      GO TO 9999
 9992 WRITE(*,'(//,'' Wrong format in Pathline file'')')
      WRITE(OUTUNT,'(//,'' Wrong format in Pathline file'')')
      CALL CLOSE_FILE (PTHFIL,*9999)
      GO TO 9999
 9993 WRITE(*,'(//,'' Exceed maximum number of arcs > '',I10)') 
     &        MAXPTS
      WRITE(OUTUNT,'(//,'' Exceed maximum number of arcs > '',I10)') 
     &        MAXPTS
      CALL CLOSE_FILE (PTHFIL,*9999)
 9999 WRITE(*,
     &      '(//,'' Abnormal termination of Pthlns_Subroutine'')')
      WRITE(OUTUNT,
     &      '(//,'' Abnormal termination of Pthlns_Subroutine'')')
      RETURN 1
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Pthprt version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 PTHPRT 05NOVEMBER1997
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Generates a vertical profile of a single particle path line
C      from the results of the particle-tracking program MODPATH using the 
C      pathline file PATHLINE.
C      This program uses an algorithm that traces a single particle into
C      one pathline, but each pathline may consist of many pathlines.
C      The algorithm separates each pathline into many pathlines using
C      each record from the pathline file PATHLINE.  Values of time-of-travel
C      are computed for each set of pathlines that remain within a single
C      cell.  If this particle changes cells then, a time-of-travel is
C      computed.
C        Attributes for each pathline for one particle are attached to
C      reflect the original particle id number, it's original starting 
C      position within the model grid, and it's final position within
C      the model grid.  
C       -- Starting attributes are those attributes that occur at time zero.  
C       -- Last attributes are those that occur over an arc defined by two
C           points.  Typically, these points are in "last" and "newly-entered"
C           cells.  
C       -- Present attributes are those attributes that represent the 
C           "newly-entered" cell.
C       -- Cumulative attributes are those attributes that are measured from
C           start position to the present position within the "newly-entered" 
C           cell.
C       -- Final attributes are those attributes that occur at the final 
C           time t and are measured from start position to final position.
C
C        Attributes (items) associated with each particle segment are:
C
C     PARTLE  : PARTICLE ATTRIBUTE ARRAY (MAXPTS,MAXATB)
C
C             => (n,1) PARTICLE-ID FROM PATHLINE OF MODPATH
C       Start attributes:
C       Last attributes:
C       Present attributes:
C       Final attributes:
C       Cumulative attributes:
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT NUMBER TO MODTOOLS.LIST
C     PRTFIL  : MODPATH OUTPUT PATHLINE FILE NAME
C     PTHUNT  : FORTRAN UNIT NUMBER TO PATHLINE FILE
C     PRTCOV  : USER DEFINED COVERAGE NAME
C     MAXATB  : MAXIMUM NUMBER OF ATTRIBUTES FOR EACH POLYGON
C                IN THE COVERAGE PAT FILE.
C     MAXPMR  : MAXIMUM NUMBER OF COVERAGE PARAMETERS
C     MAXPTS  : MAXIMUM NUMBER OF VERTICES IN A SINGLE ARC
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     COVPMR  : ARRAY FOR COVERAGE PARAMETERS (MAXPMR)
C     IBOUND  : ARRAY FOR IBOUND ARRAY
C     ZBOT    : ARRAY FOR CELL BOTTOM ELEVATIONS
C
C    Outputs:
C
C     PARTLE  : ARC ATTRIBUTE ARRAY (MAXARC,MAXATB)
C     DELX    : REAL ARRAY FOR CELL WIDTHS IN ROW/COLUMN/PARTICLE DIRECTION
C     LRWCL   : INTEGER ARRAY FOR CELL'S ROW OR COLUMN (2,NDELX)
C
C
C-------------------------------------------------------------------------
      SUBROUTINE PTHPRT (
     I                   OUTUNT,
     I                   PTHFIL,PTHUNT,
     I                   PRTCOV,
     I                   MAXATB,MAXPMR,MAXPTS,
     I                   NLAY,NROW,NCOL,
     I                   COVPMR,
     I                   IBOUND,ZBOT,
     O                   DELX,LRWCL,
     O                   PARTLE,
     E                   *)
C
C-------------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
      DIMENSION 
     &          COVPMR(MAXPMR),
     &          DELX(NCOL*NROW),
     &          LRWCL(2,NCOL*NROW),
     &          PARTLE(MAXPTS,MAXATB),
     &          IBOUND(NCOL,NROW,NLAY),
     &          ZBOT(NCOL,NROW,NLAY)
C
      CHARACTER*(*) PRTCOV,PTHFIL
      INTEGER 
     &        OUTUNT,
     &        PTHUNT
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      PARAMETER 
     &          (MAXITM=63,
     &           MXITEM=5)
C
      CHARACTER*400 BUFFER
      CHARACTER*128 COVFIL
      CHARACTER*80 STRFIL,LSTFIL,PREFIL,FINFIL,CUMFIL,
     &             GENFIL,ARCFIL,ADDFIL,JONFIL,TMPFIL
      CHARACTER*16 ARCCMD,ACTION,STRITM,RELITM,JONTYP,
     &             COVTYP,ITEMS(MAXITM)
      CHARACTER*1 TYPES(MAXITM)
C
      REAL
     &     XGC,YGC,ZGC,XTO,XFROM,
     &     XLC,YLC,ZLC,YTO,YFROM,
     &     LSTXGC,LSTXLC,LSTYGC,LSTYLC,LSTZGC,LSTZLC,LSTTIM
C
      INTEGER 
     &        STRUNT,LSTUNT,PREUNT,FINUNT,CUMUNT,
     &        GENUNT,ARCUNT,
     &        DECIMLS(MAXITM),
     &        ITMSTR(MXITEM),ITMFIN(MXITEM),
     &        OUTPUTS(MAXITM),
     &        WIDTHS(MAXITM)
C
      INTEGER 
     &        COL,ROW,LAY,BUFDEX,COMPCT,BINARY,
     &        ICOVER,MODFLG,MODFMT,IVIEW,IRWCL,
     &        IDPART,PARTID,TIMSTP,OLDSTP,
     &        STRCOL,STRROW,STRLAY,STRIBD,STRSTP,
     &        LSTCOL,LSTROW,LSTLAY,LSTIBD,
     &        PRECOL,PREROW,PRELAY,PREIBD,PRESTP,
     &        FINCOL,FINROW,FINLAY,FINIBD,FINSTP,
     &        TOTPTS,NEWPTS,OLDPTS,TOTREC,
     &        TOTARC,TOTSTN,TOTPRT,TOTCOT,PRTSTP
C
      EXTERNAL OPEN_FILE,CLOSE_FILE,DELETE_FILE
C
      DATA STRFIL,STRUNT /'startitems',98/
      DATA LSTFIL,LSTUNT /'lastitems',97/ 
      DATA PREFIL,PREUNT /'presentitems',96/
      DATA FINFIL,FINUNT /'finalitems',95/
      DATA CUMFIL,CUMUNT /'cumitems',94/
      DATA GENFIL,GENUNT /'arcs',93/
      DATA ARCFIL,ARCUNT /'arccmd',92/
C
C
      DATA ITMSTR /1, 14,25,42,59/
      DATA ITMFIN /13,24,41,58,63/
      DATA ITEMS /'PARTID','STRSTP',
     &            'STRROW','STRCOL','STRLAY','STRIBD',
     &            'STRXGC','STRXLC',
     &            'STRYGC','STRYLC',
     &            'STRZGC','STRZLC',
     &            'STRTIM',
     &            'LSTROW','LSTCOL','LSTLAY','LSTIBD',
     &            'LSTXGC','LSTXLC',
     &            'LSTYGC','LSTYLC',
     &            'LSTZGC','LSTZLC',
     &            'LSTTIM',
     &            'PRESTP',
     &            'PREROW','PRECOL','PRELAY','PREIBD',
     &            'PREXGC','PREXLC',
     &            'PREYGC','PREYLC',
     &            'PREZGC','PREZLC',
     &            'PRETIM',
     &            'PRETRV',
     &            'PREXVL','PREYVL','PREZVL','PRESPD',
     &            'PARTID','FINSTP',
     &            'FINROW','FINCOL','FINLAY','FINIBD',
     &            'FINXGC','FINXLC',
     &            'FINYGC','FINYLC',
     &            'FINZGC','FINZLC',
     &            'FINTIM',
     &            'FINXVL','FINYVL','FINZVL','FINSPD',
     &            'CUMXVL','CUMYVL','CUMZVL','CUMSPD','MODSTP'/
C
      DATA DECIMLS / 6*0,  7*3,  4*0,  7*3,  5*0,  8*3,  4*8,  6*0,
     &                7*3,  8*8,0/
      DATA TYPES   / 6*'I',7*'F',4*'I',7*'F',5*'I',8*'F',4*'F',6*'I',
     &                11*'F',4*'F','I'/
      DATA WIDTHS  / 6*10, 7*8,  4*10, 7*8,  5*10, 8*8,  4*8,  6*10,
     &                11*8,  4*8,10/
      DATA OUTPUTS / 6*10, 7*16, 4*10, 7*16, 5*10, 8*16, 4*16, 6*10,
     &                11*16, 4*16,10/
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       SINGLE PARTICLE GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''               VERSION 6.0 05NOVEMBER1997 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                  GIS OUTPUT MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C0----Pathline file
C
      IF(PTHUNT.LE.0) THEN    
         WRITE(*,'(
     &             ''      .No pathline file listed '',
     &             ''in MODPATH name file'')')
         WRITE(OUTUNT,'(
     &             ''      .No pathline file listed '',
     &             ''in MODPATH name file'')')
         GO TO 9999
      ELSE
         WRITE(*,'(
     &             ''      .Processing pathlines from Pathline file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
         WRITE(OUTUNT,'(
     &             ''      .Processing pathlines from Pathline file '',
     &             A,
     &             '' on unit number'',I5)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1),
     &       PTHUNT
      ENDIF
C
C1----Set local variables
C
      MODFLG=INT(COVPMR(1))
      XYSCALE=COVPMR(3)
      ZSCALE=COVPMR(4)
      ANGLE=COVPMR(5)
      XOGRID=COVPMR(6)
      YOGRID=COVPMR(7)
      IF(COVPMR(9).LE.0.0) COVPMR(9)=1.0
      HSCALE=12.0/COVPMR(9)
      IF(COVPMR(8).LE.0.0) COVPMR(8)=1.0
      VSCALE=HSCALE*COVPMR(8)
      IVIEW=INT(COVPMR(10))
      PARTID=INT(COVPMR(11))
      MODFMT=INT(COVPMR(MAXPMR-4))
      MODFMT=MODFMT/100
      CLLMIN=9999999999.99
      MODSTP=0
C
C2----Transform from Modpath origin (lower left) to Modular Model
C      origin (upper left)
C
      YORIGN=0.0
C
C2A----Calculate upper left corner distance from DELC array (y-axis)
C
      DO 200 ROW=NCOL+1,NCOL+NROW
         YORIGN=YORIGN+DELX(ROW)
  200 CONTINUE
C
C2B----Calculate rowcol attribute definition
C
      IF(NROW.LT.10) THEN
         LENROW=1
      ELSE IF(NROW.GT.9 .AND. NROW.LT.100) THEN
         LENROW=2
      ELSE IF(NROW.GT.99 .AND. NROW.LT.1000) THEN
         LENROW=3
      ELSE
         LENROW=4
      ENDIF
C
      IF(NCOL.LT.10) THEN
         LENCOL=1
      ELSE IF(NCOL.GT.9 .AND. NCOL.LT.100) THEN
         LENCOL=2
      ELSE IF(NCOL.GT.99 .AND. NCOL.LT.1000) THEN
         LENCOL=3
      ELSE
         LENCOL=4
      ENDIF
C
      IF(NLAY.LT.10) THEN
         LENLAY=1
      ELSE IF(NLAY.GT.9 .AND. NLAY.LT.100) THEN
         LENLAY=2
      ELSE IF(NLAY.GT.99 .AND. NLAY.LT.1000) THEN
         LENLAY=3
      ELSE
         LENLAY=4
      ENDIF
C
      WIDTHS(3)=LENROW
      OUTPUTS(3)=LENROW
      WIDTHS(4)=LENCOL
      OUTPUTS(4)=LENCOL
      WIDTHS(5)=LENLAY
      OUTPUTS(5)=LENLAY
C
      WIDTHS(14)=LENROW
      OUTPUTS(14)=LENROW
      WIDTHS(15)=LENCOL
      OUTPUTS(15)=LENCOL
      WIDTHS(16)=LENLAY
      OUTPUTS(16)=LENLAY
C
C
      WIDTHS(26)=LENROW
      OUTPUTS(26)=LENROW
      WIDTHS(27)=LENCOL
      OUTPUTS(27)=LENCOL
      WIDTHS(28)=LENLAY
      OUTPUTS(28)=LENLAY
C
      WIDTHS(44)=LENROW
      OUTPUTS(44)=LENROW
      WIDTHS(45)=LENCOL
      OUTPUTS(45)=LENCOL
      WIDTHS(46)=LENLAY
      OUTPUTS(46)=LENLAY
C
C3----Delete and create files for attribute definitions, attribute value, and
C     coverage arc data and tolerance/dangle values
C
      CALL ITEM_FILES (
     I                 STRFIL,STRUNT,
     I                 ITMSTR(1),ITMFIN(1),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 LSTFIL,LSTUNT,
     I                 ITMSTR(2),ITMFIN(2),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 PREFIL,PREUNT,
     I                 ITMSTR(3),ITMFIN(3),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 FINFIL,FINUNT,
     I                 ITMSTR(4),ITMFIN(4),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
      CALL ITEM_FILES (
     I                 CUMFIL,CUMUNT,
     I                 ITMSTR(5),ITMFIN(5),
     I                 MAXITM,
     I                 DECIMLS,
     I                 ITEMS,
     I                 OUTPUTS,
     I                 TYPES,
     I                 WIDTHS,
     E                 *9999)
C
C4----Pathline file
C
      TOTPRT=0
      TOTREC=0
      TOTARC=0
      TOTCOT=0
      TIMSTP=0
C
C4A----Determine particle format
C
      IF(MODFMT.LT.1) THEN    
         WRITE(*,'(7X,
     &             ''..Using standard text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.1) THEN    
         WRITE(*,'(7X,
     &             '' Using compact text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ELSE
         WRITE(*,'(7X,
     &             '' Using binary text format'')')
         NSTAT=-4
         ITALK=1
         CALL OPEN_FILE (-ABS(PTHUNT),PTHFIL,NSTAT,ITALK,*9999)
      ENDIF
C
C4A----Print output header line
C
      WRITE(OUTUNT,'(//,1H1,32X,
     &               ''  PARTICLE POSITION RECORDS (MAPVIEW)'',
     &               /10X,105(''-''),/10X,
     &               '' PARTICLE ID'',
     &               ''    COLUMN'',
     &               ''       ROW'',
     &               ''     LAYER'',
     &               ''       X GLOBAL    '',
     &               ''       Y GLOBAL    '',
     &               ''                TIME'',
     &               /10X,105(''-''))')
C
C4C----Read header line from pathline file
C
      IF(MODFMT.LT.2) THEN    
         READ(PTHUNT,'(A)',ERR=9990,END=9991) BUFFER
         MODPTH=INDEX(BUFFER,'Version 3.00')
         COMPCT=INDEX(BUFFER,'(COMPACT)')
         BUFDEX=INDEX(BUFFER,'TREF=')
       IF(BUFDEX.GT.0) THEN
          BUFFER=BUFFER (BUFDEX+5:LEN(BUFFER))
          BUFDEX=INDEX(BUFFER,')')
        IF(BUFDEX.LE.0) BUFDEX=LEN(BUFFER)
          READ(BUFFER (1:BUFDEX-1),*) TREF
       ELSE
          TREF=0.0
       ENDIF
      ELSE
         READ(PTHUNT,ERR=9990,END=9991) BUFFER
         MODPTH=INDEX(BUFFER,'Version 3.00')
         BINARY=INDEX(BUFFER,'(BINARY)')
      ENDIF
C
C4C----Check format of pathline file
C
      IF(MODFMT.EQ.0 .AND. MODPTH.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in MODPATH version 3.0 text format '')')
         WRITE(*,'(''      ..Using standard text format '',
     &             ''for MODPATH version 2.0 '')')
         MODFMT=9
         CALL CLOSE_FILE (PTHFIL,*9999)
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (PTHUNT,PTHFIL,NSTAT,ITALK,*9999)
      ENDIF
C
      IF(MODFMT.EQ.1 .AND. COMPCT.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in compact format '')')
         GO TO 9999
      ENDIF
C
      IF(MODFMT.EQ.2 .AND. BINARY.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in binary format '')')
         GO TO 9999
      ENDIF
C
C4D---Loop to read arcs from pathline file
C
      TOTPRT=0
       TRVTIM=0.0
        OLDTIM=0.0
         XGCPTH=0.0
          YGCPTH=0.0
           ZGCPTH=0.0
            PRTPTH=0.0
C
  402 IF(MODFMT.LT.1) THEN    
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           COL,ROW,LAY,
     &           MODSTP
      ELSE IF(MODFMT.EQ.1) THEN
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           NODE,
     &           MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE IF(MODFMT.EQ.2) THEN
         READ(PTHUNT,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           NODE,
     &           MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE
         READ(PTHUNT,*,ERR=9992,END=502)
     &           IDPART,
     &           XGC,YGC,ZLC,ZGC,
     &           TIME,
     &           COL,ROW,LAY
         MODSTP=0
      ENDIF
C
C4Da----Check for chosen particle and count particle positions
C
        TOTREC=TOTREC+1
      IF(IDPART.NE.PARTID) GO TO 402
         TOTPRT=TOTPRT+1
        IF(TOTPRT.GT.MAXPTS) GO TO 9993
C
C4Db----Load minimum cell elevation
C
      DO 400 NUMLAY=1,NLAY
       IF(IBOUND(COL,ROW,NUMLAY).NE.0) THEN
          YBOT=ZBOT(COL,ROW,NUMLAY)*ZSCALE*VSCALE
        IF(YBOT.LT.CLLMIN) CLLMIN=YBOT
       ENDIF
 400  CONTINUE
C
C4Db----Compute local x-,y-coordinates
C
      CALL LOCAL_COORDINATES (
     I                        NCOL,NROW,
     I                        DELX,
     I                        COL,ROW,
     I                        XGC,YGC,YORIGN,
     O                        XLC,YLC)
      WRITE(OUTUNT,'(10X,I12,I10,I10,I10,3(G19.5,1X))')
     &                                                 IDPART,
     &                                                 COL,
     &                                                 ROW,
     &                                                 LAY,
     &                                                 XGC,
     &                                                 YGC,
     &                                                 TIME
C
C4Dc----Compute arc node points, transform and assign coordinates,
C--------and obtain particle-time
C
      XGC=XGC*XYSCALE
       YGC=(YGC-YORIGN)*XYSCALE
        ZGC=ZGC*ZSCALE
C
C4Dd----Test time step index number and particle ids
C
      IF(TIME.LT.0.0000000000001) TIME=0.0
       IF(TIME.EQ.OLDTIM) TIMSTP=TIMSTP+1
         OLDTIM=TIME
C
C4Df-----Load start and print attributes
C
      IF(TOTPRT.LE.1) THEN
         PARTLE(1,1)=IDPART
         PARTLE(1,2)=TIMSTP
         PARTLE(1,3)=ROW
         PARTLE(1,4)=COL
         PARTLE(1,5)=LAY
         PARTLE(1,6)=IBOUND(COL,ROW,LAY)
         PARTLE(1,7)=XGC
         PARTLE(1,8)=XLC
         PARTLE(1,9)=YGC
         PARTLE(1,10)=YLC
         PARTLE(1,11)=ZGC
         PARTLE(1,12)=ZLC
         PARTLE(1,13)=TIME
         STRSTP=TIMSTP
         STRROW=ROW
         STRCOL=COL
         STRLAY=LAY
         STRIBD=IBOUND(COL,ROW,LAY)
         STRXGC=XGC
         STRXLC=XLC
         STRYGC=YGC
         STRYLC=YLC
         STRZGC=ZGC
         STRZLC=ZLC
         STRTIM=TIME
         LSTXGC=XGC
         LSTYGC=YGC
         LSTZGC=ZGC
      ENDIF
C
C4Dh----Load present attributes
C
      PARTLE(TOTPRT,25)=TIMSTP
      PARTLE(TOTPRT,26)=ROW
      PARTLE(TOTPRT,27)=COL
      PARTLE(TOTPRT,28)=LAY
      PARTLE(TOTPRT,29)=IBOUND(COL,ROW,LAY)
      PARTLE(TOTPRT,30)=XGC
      PARTLE(TOTPRT,31)=XLC
      PARTLE(TOTPRT,32)=YGC
      PARTLE(TOTPRT,33)=YLC
      PARTLE(TOTPRT,34)=ZGC
      PARTLE(TOTPRT,35)=ZLC
      PARTLE(TOTPRT,36)=TIME
      PARTLE(TOTPRT,37)=ABS(TIME-FINTIM)
      PARTLE(TOTPRT,63)=MODSTP
      FINTIM=TIME
C
C4Dh----Load final attributes
C
      FINSTP=TIMSTP
      FINROW=ROW
      FINCOL=COL
      FINLAY=LAY
      FINIBD=IBOUND(COL,ROW,LAY)
      PARTLE(1,48)=XGC
      PARTLE(1,49)=XLC
      PARTLE(1,50)=YGC
      PARTLE(1,51)=YLC
      PARTLE(1,52)=ZGC
      PARTLE(1,53)=ZLC
      PARTLE(1,54)=TIME
      XGCPTH=XGCPTH+ABS(XGC-LSTXGC)
      YGCPTH=XGCPTH+ABS(YGC-LSTYGC)
      ZGCPTH=XGCPTH+ABS(ZGC-LSTZGC)
      PRTPTH=PRTPTH+(XGCPTH**2+YGCPTH**2+ZGCPTH**2)**0.5
C
C4Dh----Load last attributes
C
      LSTXGC=XGC
      LSTYGC=YGC
      LSTZGC=ZGC
C
C4Am----Read another record from pathline file
C
      GO TO 402
C
C5A----Close PTHFIL, arc attribute, and generate files
C
  502 CALL CLOSE_FILE (PTHFIL,*9999)
C
C5B----Check the number of particles and records in pathline file
C
      IF(TOTREC.LE.0) THEN
         WRITE(*,'(''      .No particle records found in '',
     &             ''Pathline file '',
     &          A)')
     &       PTHFIL (1:INDEX(PTHFIL,' ')-1)
         GO TO 9999
      ENDIF
      IF(TOTPRT.LE.0) THEN
         WRITE(*,'(
     &         ''      .No matching records for particle '',I10)')
     &                                                PARTID
         WRITE(*,'(
     &         ''      ..in Pathline file '',A)')
     &                                  PTHFIL (1:INDEX(PTHFIL,' ')-1)
         WRITE(OUTUNT,'(
     &         ''      .No matching records for particle '',I10)')
     &                                                PARTID
         WRITE(OUTUNT,'(
     &         ''      ..in Pathline file '',A)')
     &                                  PTHFIL (1:INDEX(PTHFIL,' ')-1)
         GO TO 9999
      ENDIF
      IF(TOTPRT.GT.0 .AND. STRTIM.EQ.FINTIM) THEN
         WRITE(*,'(''      .Particle '',I10,
     &             '' remained stationary'')')
     &       PARTID
         WRITE(OUTUNT,'(''      .Particle '',I10,
     &             '' remained stationary'')')
     &       PARTID
         GO TO 9999
      ENDIF
C
C6C----Compute and load last attributes
C
      LSTSTP=STRSTP
      LSTROW=STRROW
      LSTCOL=STRCOL
      LSTLAY=STRLAY
      LSTIBD=STRIBD
      LSTXGC=PARTLE(1,7)
      LSTXLC=PARTLE(1,8)
      LSTYGC=PARTLE(1,9)
      LSTYLC=PARTLE(1,10)
      LSTZGC=PARTLE(1,11)
      LSTZLC=PARTLE(1,12)
      LSTTIM=PARTLE(1,13)
C
C6C----Compute and load final attributes
C
      XGCVEL=0.0
      YGCVEL=0.0
      ZGCVEL=0.0
      PRTSPD=0.0
      TRVTIM=FINTIM-STRTIM
C
      IF(TRVTIM.GT.0.0) THEN
         XGCVEL=XGCPTH/TRVTIM
         YGCVEL=YGCPTH/TRVTIM
         ZGCVEL=ZGCPTH/TRVTIM
         PRTSPD=PRTPTH/TRVTIM
       IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
       IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
       IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
       IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
      ENDIF
C
      PARTLE(1,55)=XGCVEL
      PARTLE(1,56)=YGCVEL
      PARTLE(1,57)=ZGCVEL
      PARTLE(1,58)=PRTSPD
C
C6----Write final arc attribute
C
      XFROM=0.0
      TOTSTN=0
      TOTARC=0
C
C6A---Delete/create files containing Arc/Info particle attribute
C       and Arc command files
C
      NSTAT=2
      ITALK=1
      STRFIL='start'
      CALL DELETE_FILE (STRFIL,*9999)
      CALL OPEN_FILE (STRUNT,STRFIL,NSTAT,ITALK,*9999)
      LSTFIL='last'
      CALL DELETE_FILE (LSTFIL,*9999)
      CALL OPEN_FILE (LSTUNT,LSTFIL,NSTAT,ITALK,*9999)
      PREFIL='present'
      CALL DELETE_FILE (PREFIL,*9999)
      CALL OPEN_FILE (PREUNT,PREFIL,NSTAT,ITALK,*9999)
      CUMFIL='cum'
      CALL DELETE_FILE (CUMFIL,*9999)
      CALL OPEN_FILE (CUMUNT,CUMFIL,NSTAT,ITALK,*9999)
      FINFIL='final'
      CALL DELETE_FILE (FINFIL,*9999)
      CALL OPEN_FILE (FINUNT,FINFIL,NSTAT,ITALK,*9999)
      GENFIL='arcs'
      CALL DELETE_FILE (GENFIL,*9999)
      CALL OPEN_FILE (GENUNT,GENFIL,NSTAT,ITALK,*9999)
C
      WRITE(OUTUNT,'(//,1H1,35X,
     &               ''  PARTICLES POSITIONS '',
     &               ''IN FLOWLINE COVERAGE'')')
      WRITE(OUTUNT,'(10X,95(''-''))')
      WRITE(OUTUNT,'(10X,
     &               ''  PARTICLE-ID'',
     &             3(''   PRESENT''),
     &               ''   PRESENT'',
     &               ''   PRESENT'',
     &               ''         PRESENT'',
     &               ''        PREVIOUS'')')
      WRITE(OUTUNT,'(22X,
     &               ''       ROW'',
     &               ''    COLUMN'',
     &               ''     LAYER'',
     &               ''  GLOBAL X'',
     &               ''  GLOBAL Y'',
     &               ''           TIME'',
     &               ''           TIME'')')
      WRITE(OUTUNT,'(10X,95(''-''))')
C
C6B----Print first position and attributes
C
         WRITE(OUTUNT,'(10X,
     &                  ''START       '',
     &                  I10,I10,I10,2(G10.3,1X),2(G15.3,1X))')
     &                                                 STRCOL,
     &                                                 STRROW,
     &                                                 STRLAY,
     &                                                 STRXGC,
     &                                                 STRYGC,
     &                                                 STRZGC,
     &                                                 STRTIM
C
C6D----Loop to compute arcs and load attributes
C
      TOTARC=0
      XFROM=0.0
      YFROM=LSTZGC*VSCALE-CLLMIN
      CLLWTH=0.0
      XGCPTH=0.0
      YGCPTH=0.0
      ZGCPTH=0.0
      PRTPTH=0.0
      DO 600 N=2,TOTPRT
         PRESTP=INT(PARTLE(N,25))
         PREROW=INT(PARTLE(N,26))
         PRECOL=INT(PARTLE(N,27))
         PRELAY=INT(PARTLE(N,28))
         PREIBD=INT(PARTLE(N,29))
         PREIBD=INT(PARTLE(N,29))
         PREXGC=PARTLE(N,30)
         PREXLC=PARTLE(N,31)
         PREYGC=PARTLE(N,32)
         PREYLC=PARTLE(N,33)
         PREZGC=PARTLE(N,34)
         PREZLC=PARTLE(N,35)
         PRETIM=PARTLE(N,36)
         TRVTIM=ABS(PRETIM-LSTTIM)
C
         XGCARC=ABS(PREXGC-LSTXGC)
         YGCARC=ABS(PREYGC-LSTYGC)
         ZGCARC=ABS(PREZGC-LSTZGC)
         WRITE(OUTUNT,'(10X,
     &                  ''  SEGMENT   '',
     &                  I10,I10,I10,2(G10.3,1X),2(G15.3,1X))')
     &                                                 PRECOL,
     &                                                 PREROW,
     &                                                 PRELAY,
     &                                                 XGCARC,
     &                                                 YGCARC,
     &                                                 ZGCARC,
     &                                                 TRVTIM
C
       IF(XGCARC.LE.0.0001 .AND. YGCARC.LE.0.0001) THEN
          TOTCOT=TOTCOT+1
          WRITE(OUTUNT,'(10X,
     &                  ''  STATIONARY'',
     &                  I10,I10,I10,2(G10.3,1X),2(G15.3,1X))')
     &                                                 PRECOL,
     &                                                 PREROW,
     &                                                 PRELAY,
     &                                                 XGCARC,
     &                                                 YGCARC,
     &                                                 ZGCARC,
     &                                                 TRVTIM
          GO TO 602
       ENDIF
C
C6C----Compute and load start attributes
C
         IDPART=INT(PARTLE(1,1))
         STRSTP=INT(PARTLE(1,2))
         STRROW=INT(PARTLE(1,3))
         STRCOL=INT(PARTLE(1,4))
         STRLAY=INT(PARTLE(1,5))
         STRIBD=INT(PARTLE(1,6))
         WRITE(STRUNT,'(6(I10,'',''),
     &                 6(G16.6,'',''),
     &                 1(G16.3,'',''))')
     &                                  IDPART,
     &                                  STRSTP,
     &                                  STRROW,
     &                                  STRCOL,
     &                                  STRLAY,
     &                                  STRIBD,
     &                                  (PARTLE(1,M), M=7,13)
C
C6C----Compute and load final attributes
C
         WRITE(FINUNT,'(I10,'','',
     &                  5(I5,'',''),
     &                  6(G16.6,'',''),
     &                  1(G16.3,'',''),
     &                  4(G16.8,'',''))')
     &                                    IDPART,
     &                                    FINSTP,
     &                                    FINROW,
     &                                    FINCOL,
     &                                    FINLAY,
     &                                    FINIBD,
     &                                    (PARTLE(1,M), M=48,58)
C
C6C----Compute present velocities
C
         XGCVEL=0.0
         YGCVEL=0.0
         ZGCVEL=0.0
         PRTSPD=0.0
       IF(TRVTIM.GT.0.0) THEN
          XGCVEL=XGCARC/TRVTIM
          YGCVEL=YGCARC/TRVTIM
          ZGCVEL=ZGCZRC/TRVTIM
          ARCPTH=(XGCARC**2+YGCPTH**2+ZGCPTH**2)**0.5
          PRTSPD=ARCPTH/TRVTIM
        IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
        IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
        IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
        IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
       ENDIF
C
C6Di----Print present attributes
C
         PARTLE(N,37)=TRVTIM
         PARTLE(N,38)=XGCVEL
         PARTLE(N,39)=YGCVEL
         PARTLE(N,40)=ZGCVEL
         PARTLE(N,41)=PRTSPD
         WRITE(PREUNT,'(5(I5,'',''),
     &                  6(G16.6,'',''),
     &                  2(G16.3,'',''),
     &                  4(G16.8,'',''))')
     &                                  PRESTP,
     &                                  PREROW,
     &                                  PRECOL,
     &                                  PRELAY,
     &                                  PREIBD,
     &                                  (PARTLE(N,M), M=30,41)
C
C6Dl----Compute cell width
C
         ARCPTH=(XGCARC**2+YGCARC**2)**0.5
         CLLWTH=CLLWTH+ARCPTH
       IF(PREROW.NE.LSTROW .OR. PRECOL.NE.LSTCOL) THEN
          TOTARC=TOTARC+1
          DELX(TOTARC)=CLLWTH
          LRWCL(1,TOTARC)=LSTCOL
          LRWCL(2,TOTARC)=LSTROW
          WRITE(OUTUNT,'(10X,
     &                  ''  FINAL WIDTH'',
     &                  I10,I10,32X,2(G15.3,1X))')
     &                                                 LSTCOL,
     &                                                 LSTROW,
     &                                                 ARCPTH,
     &                                                 CLLWTH
          WRITE(OUTUNT,'(/)')
          CLLWTH=0.0
       ELSE
          WRITE(OUTUNT,'(10X,
     &                  ''  CELL WIDTH  '',
     &                  20X,I10,22X,2(G15.3,1X))')
     &                                                 TOTARC,
     &                                                 ARCPTH,
     &                                                 CLLWTH
       ENDIF
C
C6Dl----Write coordinates and label-ids to generate file
C
         XTO=XFROM+ARCPTH*HSCALE
         YTO=PREZGC*VSCALE-CLLMIN
         WRITE(GENUNT,'(I10)') IDPART
         WRITE(GENUNT,'(F20.10,'','',F20.10,/,
     &                  F20.10,'','',F20.10)')
     &                                             XFROM,
     &                                             YFROM,
     &                                             XTO,
     &                                             YTO
         WRITE(GENUNT,'(''END'')')
         XFROM=XTO
         YFROM=YTO
C
C6Dk----Load cumulative attributes
C
         TRVTIM=ABS(PRETIM-STRTIM)
         XGCVEL=0.0
         YGCVEL=0.0
         ZGCVEL=0.0
         PRTSPD=0.0
         XGCPTH=XGCPTH+XGCARC
         YGCPTH=YGCPTH+YGCARC
         ZGCPTH=ZGCPTH+ZGCARC
         PRTPTH=PRTPTH+(XGCPTH**2+YGCPTH**2+ZGCPTH**2)**0.5
       IF(TRVTIM.GT.0.0) THEN
          XGCVEL=XGCPTH/TRVTIM
          YGCVEL=YGCPTH/TRVTIM
          ZGCVEL=ZGCPTH/TRVTIM
          PRTSPD=PRTPTH/TRVTIM
        IF(ABS(XGCVEL).LE.0.00000001) XGCVEL=SIGN(0.00000001,XGCVEL)
        IF(ABS(YGCVEL).LE.0.00000001) YGCVEL=SIGN(0.00000001,YGCVEL)
        IF(ABS(ZGCVEL).LE.0.00000001) ZGCVEL=SIGN(0.00000001,ZGCVEL)
        IF(PRTSPD.LE.0.00000001) PRTSPD=0.00000001
       ENDIF
C
         PARTLE(1,59)=XGCVEL
         PARTLE(1,60)=YGCVEL
         PARTLE(1,61)=ZGCVEL
         PARTLE(1,62)=PRTSPD
         MODSTP=PARTLE(N,63)
         WRITE(CUMUNT,'(4(G16.8,'',''),
     &                  I10)')
     &                                (PARTLE(1,M), M=59,62),
     &                                MODSTP
C
C6Di----Print and load last attributes
C
         WRITE(LSTUNT,'(4(I10,'',''),
     &                  6(G16.6,'',''),
     &                  1(G16.3,'',''))')
     &                                   LSTROW,
     &                                   LSTCOL,
     &                                   LSTLAY,
     &                                   LSTIBD,
     &                                   (PARTLE(1,M), M=18,24)
C
 602     LSTROW=PREROW
         LSTCOL=PRECOL
         LSTLAY=PRELAY
         LSTIBD=PREIBD
         LSTXGC=PREXGC
         PARTLE(1,18)=LSTXGC
         LSTXLE=PREXLC
         PARTLE(1,19)=LSTXLC
         LSTYGC=PREYGC
         PARTLE(1,20)=LSTYGC
         LSTYLC=PREYLC
         PARTLE(1,21)=LSTYLC
         LSTZGC=PREZGC
         PARTLE(1,22)=LSTZGC
         LSTZLC=PREZLC
         PARTLE(1,23)=LSTZLC
         LSTTIM=PRETIM
         PARTLE(1,24)=LSTTIM
  600 CONTINUE
C
C6A----Last cell
C
      IF(CLLWTH.GT.0.0) THEN
         TOTARC=TOTARC+1
         DELX(TOTARC)=CLLWTH
         LRWCL(1,TOTARC)=LSTCOL
         LRWCL(2,TOTARC)=LSTROW
      ENDIF
C
C6A----Set parameters
C
      COVPMR(11)=TOTARC
      COVPMR(MAXPMR)=CLLMIN
C
C6A----Add "end" to generate file
C
      WRITE(GENUNT,'(''END'')')
C
C6C----Close all attribute and generate files
C
      CALL CLOSE_FILE (GENFIL,*9999)
      CALL CLOSE_FILE (STRFIL,*9999)
      CALL CLOSE_FILE (LSTFIL,*9999)
      CALL CLOSE_FILE (PREFIL,*9999)
      CALL CLOSE_FILE (CUMFIL,*9999)
      CALL CLOSE_FILE (FINFIL,*9999)
C
C7----Messages
C
C
C7A----Message to user
C
      WRITE(*,'(''      Pathline coverage '',A,
     &          '' consists of '')')
     &        PRTCOV (1:INDEX(PRTCOV,' ')-1)
      WRITE(*,'(''      .'',I10,
     &          '' total number of particle records'')')
     &        TOTREC
      WRITE(*,'(''      .'',I10,
     &          '' total number of matching records found'')')
     &        TOTPRT
      WRITE(*,'(''      .'',I10,
     &          '' particle ID'')')
     &        PARTID
      WRITE(*,'(''      .'',I10,
     &          '' number of pathline segments generated '')')
     &        TOTARC
      WRITE(*,'(''      .'',I10,
     &          '' particles that remained stationary'')')
     &        TOTSTN
      WRITE(*,'(''      .'',I10,
     &          '' particle records that are concident '',
     &          ''when projected'')')
     &        TOTCOT
      WRITE(*,'(''      .'',G16.7,
     &          '' simulation reference time '')')
     &       TREF
C
C7B----Message to operational output file
C
      WRITE(OUTUNT,'(''      Pathline coverage '',A,
     &          '' consists of '')')
     &        PRTCOV (1:INDEX(PRTCOV,' ')-1)
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' total number of particle records'')')
     &        TOTREC
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' total number of matching records found'')')
     &        TOTPRT
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' particle ID'')')
     &        PARTID
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' number of pathline segments generated '')')
     &        TOTARC
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' particles that remained stationary'')')
     &        TOTSTN
      WRITE(OUTUNT,'(''      .'',I10,
     &          '' particle records that are concident '',
     &          ''when projected'')')
     &        TOTCOT
      WRITE(OUTUNT,'(''      .'',G16.7,
     &          '' simulation reference time '')')
     &       TREF
C
C8----Arc Operations to coverage and attribute files
C
      NSTAT=2
      ITALK=1
      ARCFIL='arccmd'
      CALL DELETE_FILE (ARCFIL,*9999)
      CALL OPEN_FILE (ARCUNT,ARCFIL,NSTAT,ITALK,*9999)
C
C8A----Create pathline coverage
C
      ARCCMD='create'
      WRITE(ARCUNT,'(A,1X,A)') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1)
C
C8B----Create attribute files and "add from" attributes
C
      ARCCMD='tables'
      TMPFIL='startitems'
      ADDFIL='start'
      ACTION='kill'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='lastitems'
      ADDFIL='last'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='presentitems'
      ADDFIL='present'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='finalitems'
      ADDFIL='final'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
      ARCCMD='tables'
      TMPFIL='cumitems'
      ADDFIL='cum'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1),
     &                             ACTION (1:INDEX(ACTION,' ')-1)
C
C8C----Generate Coverage PRTCOV
C
      ARCCMD='generate'
      COVTYP='lines'
      JONFIL='arcs'
      WRITE(ARCUNT,'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
C
C8D----Build Coverage PRTCOV
C
      ARCCMD='build'
      COVTYP='line'
      WRITE(ARCUNT,'(A,2(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             PRTCOV (1:INDEX(PRTCOV,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
C
C8E---Join attribute files start, present,final to Coverage PRTCOV AAT file
C
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='final'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='cum'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='present'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='last'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      ARCCMD='joinitem'
      COVFIL=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'.AAT'
      JONFIL='start'
      RELITM='$recno'
      STRITM=PRTCOV (1:INDEX(PRTCOV,' ')-1)//'-ID'
      JONTYP='link'      
      WRITE(ARCUNT,'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             JONFIL (1:INDEX(JONFIL,' ')-1),
     &                             COVFIL (1:INDEX(COVFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
C
C8F----Close arc commands file
C
      CALL CLOSE_FILE (ARCFIL,*9999)
       GO TO 1000
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                        Program Errors
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
CE*********************************************************************C
 9990 WRITE(*,'(//,'' Unable to read first line from Pathline file'')')
      CALL CLOSE_FILE (PTHFIL,*9999)
      GO TO 9999
 9991 WRITE(*,'(//,'' Premature end-of-line error in Pathline file'')')
      GO TO 9999
 9992 WRITE(*,'(//,'' Wrong format in Pathline file'')')
      CALL CLOSE_FILE (PTHFIL,*9999)
      GO TO 9999
 9993 WRITE(*,'(//,'' Exceed maximum number of arcs > '',I10)') 
     &        MAXPTS
      CALL CLOSE_FILE (PTHFIL,*9999)
 9999 WRITE(*,'(//,'' Abnormal termination of Pthprt_Subroutine'')')
      RETURN 1
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
